
public class Queue1 extends Queue
{
	private int n, head, tail;
	
	private char[] q;
	
	public Queue1(int max)
	{
		q = new char[max+1];
		n = max+1;
		clear();
	}
	
	public void clear()
	{
		head = tail = 0;
	}
	
	public char get()
	{
		char val = q[head++];
		head = head % n;
		return val;
	}
	
	public int getSize()
	{
		return (tail >= head) ? tail - head : n - Math.abs(tail - head);
	}
	
	public boolean isEmpty()
	{
		return (head == tail);
	}
	
	public void print()
	{
		for(int pos=0; pos < n; pos++)
		{
			boolean isInQueue = 
				(head < tail && pos >= head && pos < tail)
				|| (head > tail && (pos >= head || pos < tail));
			
			Out.print(String.format(" %c", isInQueue ? q[pos] : '.'));
		}
	}
	
	public void printInOrder()
	{
		if(isEmpty()) return;
		
		int pos = head;
		do
		{
			Out.print(String.format(" %c", q[pos]));
			pos++;
			pos = pos % n;
		}
		while(pos != tail);
	}
	public void put(char val)
	{
		q[tail++] = val;
		tail = tail % n;
	}
}
